
LIBRARY ieee;
USE ieee.std_logic_1164.ALL;

ENTITY bug_trap_controller_tb IS
END bug_trap_controller_tb;
ARCHITECTURE behavioral OF bug_trap_controller_tb IS 

   COMPONENT bug_trap_controller
   PORT( CLK	   :	IN	STD_LOGIC; 
         CLR	   :	IN	STD_LOGIC; 
         LED	   :	OUT	STD_LOGIC; 
         SERVO	   :	OUT	STD_LOGIC; 
         FIRE	   :	IN	STD_LOGIC; 
         SENSOR_2	:	IN	STD_LOGIC; 
         SENSOR_1	:	IN	STD_LOGIC; 
         MODE	   :	IN	STD_LOGIC);
   END COMPONENT;

   SIGNAL CLK	:	STD_LOGIC;
   SIGNAL CLR	:	STD_LOGIC;
   SIGNAL LED	:	STD_LOGIC;
   SIGNAL SERVO	:	STD_LOGIC;
   SIGNAL FIRE	:	STD_LOGIC;
   SIGNAL SENSOR_2	:	STD_LOGIC;
   SIGNAL SENSOR_1	:	STD_LOGIC;
   SIGNAL MODE	:	STD_LOGIC;

BEGIN

   UUT: bug_trap_controller PORT MAP(
		CLK => CLK, 
		CLR => CLR, 
		LED => LED, 
		SERVO => SERVO, 
		FIRE => FIRE, 
		SENSOR_2 => SENSOR_2, 
		SENSOR_1 => SENSOR_1, 
		MODE => MODE
   );

   clock : PROCESS
   BEGIN
      CLK <= '0'; wait for 50 ns;
      CLK <= '1'; wait for 50 ns;		
   END PROCESS;
	
   clear : PROCESS
   BEGIN
      CLR <= '1'; wait for 150 ns;
      CLR <= '0'; wait;		
   END PROCESS;
	
-- *** Test Bench - User Defined Section ***
   tb : PROCESS
   BEGIN
	   FIRE     <= '1';
      MODE     <= '1';  
      SENSOR_2 <= '0';
      SENSOR_1 <= '0';
		WAIT FOR 100 ns;
		
	   FIRE     <= '0';
      MODE     <= '1';  
      SENSOR_2 <= '0';
      SENSOR_1 <= '0';
		WAIT FOR 2000 ns;
		
	   FIRE     <= '1';
      MODE     <= '1';  
      SENSOR_2 <= '0';
      SENSOR_1 <= '0';
		WAIT FOR 6000 ns;
		
	   FIRE     <= '0';
      MODE     <= '1';  
      SENSOR_2 <= '0';
      SENSOR_1 <= '0';
		WAIT FOR 2000 ns;
		
	   FIRE     <= '1';
      MODE     <= '1';  
      SENSOR_2 <= '0';
      SENSOR_1 <= '0';
		WAIT FOR 6000 ns;		
		
   END PROCESS;
-- *** End Test Bench - User Defined Section ***

END;
